default:
  image: docker:latest
  services:
    - docker:dind
  before_script:
      - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

stages:
  - build
  - test
  - release

variables:
  TEST_IMAGE_PHP: $CI_REGISTRY/webgears-gmbh/docker/php:$CI_COMMIT_REF_NAME
  TEST_IMAGE_CYPRESS: $CI_REGISTRY/webgears-gmbh/docker/cypress:$CI_COMMIT_REF_NAME
  RELEASE_IMAGE_PHP: $CI_REGISTRY/webgears-gmbh/docker/php
  RELEASE_IMAGE_CYPRESS: $CI_REGISTRY/webgears-gmbh/docker/cypress:latest

build-php74:
  stage: build
  timeout: 2h
  script:
    - docker build --pull --target php74 -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4 .
    - docker build --pull --target php74-node14 -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-node14 .
    - docker build --pull --target php74-node16 -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-node16 .
    - docker build --pull --target php74-python-node14 -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-python-node14 .
    - docker build --pull --target php74-python-node16 -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-python-node16 .
    - docker build --pull --target php74-eb -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-eb --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_USER=${DEPENDENCY_SCAN_DEPLOY_TOKEN_USER} --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE=${DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE} .
    - docker build --pull --target php74-node14-fpm -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-node14-fpm .
    - docker build --pull --target php74-node16-fpm -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-node16-fpm .
    - docker build --pull --target php74-node16-dependency-scan -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-node16-dependency-scan --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_USER=${DEPENDENCY_SCAN_DEPLOY_TOKEN_USER} --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE=${DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE} .
    - docker build --pull --target php74-node14-dependency-scan -f php74.Dockerfile -t $TEST_IMAGE_PHP-7.4-node14-dependency-scan --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_USER=${DEPENDENCY_SCAN_DEPLOY_TOKEN_USER} --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE=${DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE} .
    - docker push $TEST_IMAGE_PHP-7.4
    - docker push $TEST_IMAGE_PHP-7.4-node14
    - docker push $TEST_IMAGE_PHP-7.4-node16
    - docker push $TEST_IMAGE_PHP-7.4-python-node14
    - docker push $TEST_IMAGE_PHP-7.4-python-node16
    - docker push $TEST_IMAGE_PHP-7.4-eb
    - docker push $TEST_IMAGE_PHP-7.4-node14-fpm
    - docker push $TEST_IMAGE_PHP-7.4-node16-fpm
    - docker push $TEST_IMAGE_PHP-7.4-node16-dependency-scan
    - docker push $TEST_IMAGE_PHP-7.4-node14-dependency-scan

build-php80:
  stage: build
  timeout: 1h
  script:
    - docker build --pull --target php80 -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0 .
    - docker build --pull --target php80-node14 -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-node14 .
    - docker build --pull --target php80-node16 -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-node16 .
    - docker build --pull --target php80-python -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-python .
    - docker build --pull --target php80-eb -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-eb .
    - docker build --pull --target php80-node14-fpm -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-node14-fpm .
    - docker build --pull --target php80-node16-fpm -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-node16-fpm .
    - docker build --pull --target php80-node16-dependency-scan -f php80.Dockerfile -t $TEST_IMAGE_PHP-8.0-node16-dependency-scan --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_USER=${DEPENDENCY_SCAN_DEPLOY_TOKEN_USER} --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE=${DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE} .
    - docker push $TEST_IMAGE_PHP-8.0
    - docker push $TEST_IMAGE_PHP-8.0-node14
    - docker push $TEST_IMAGE_PHP-8.0-node16
    - docker push $TEST_IMAGE_PHP-8.0-python
    - docker push $TEST_IMAGE_PHP-8.0-eb
    - docker push $TEST_IMAGE_PHP-8.0-node14-fpm
    - docker push $TEST_IMAGE_PHP-8.0-node16-fpm
    - docker push $TEST_IMAGE_PHP-8.0-node16-dependency-scan

build-php81:
  stage: build
  timeout: 1h
  script:
    - docker build --pull --target php81 -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1 .
    - docker build --pull --target php81-node14 -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-node14 .
    - docker build --pull --target php81-node16 -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-node16 .
    - docker build --pull --target php81-python -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-python .
    - docker build --pull --target php81-eb -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-eb .
    - docker build --pull --target php81-node14-fpm -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-node14-fpm .
    - docker build --pull --target php81-node16-fpm -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-node16-fpm .
    - docker build --pull --target php81-node16-dependency-scan -f php81.Dockerfile -t $TEST_IMAGE_PHP-8.1-node16-dependency-scan --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_USER=${DEPENDENCY_SCAN_DEPLOY_TOKEN_USER} --build-arg DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE=${DEPENDENCY_SCAN_DEPLOY_TOKEN_VALUE} .
    - docker push $TEST_IMAGE_PHP-8.1
    - docker push $TEST_IMAGE_PHP-8.1-node14
    - docker push $TEST_IMAGE_PHP-8.1-node16
    - docker push $TEST_IMAGE_PHP-8.1-python
    - docker push $TEST_IMAGE_PHP-8.1-eb
    - docker push $TEST_IMAGE_PHP-8.1-node14-fpm
    - docker push $TEST_IMAGE_PHP-8.1-node16-fpm
    - docker push $TEST_IMAGE_PHP-8.1-node16-dependency-scan

build-cypress:
  stage: build
  timeout: 30m
  script:
    - docker build --pull -f cypress.Dockerfile -t $TEST_IMAGE_CYPRESS .
    - docker push $TEST_IMAGE_CYPRESS

test-php74:
  needs: [build-php74]
  stage: test
  before_script:
    - docker pull $TEST_IMAGE_PHP-7.4
    - docker pull $TEST_IMAGE_PHP-7.4-node14
    - docker pull $TEST_IMAGE_PHP-7.4-node14-fpm
    - docker pull $TEST_IMAGE_PHP-7.4-node16
    - docker pull $TEST_IMAGE_PHP-7.4-node16-fpm
    - docker pull $TEST_IMAGE_PHP-7.4-python-node14
    - docker pull $TEST_IMAGE_PHP-7.4-python-node16
    - docker pull $TEST_IMAGE_PHP-7.4-eb
    - docker pull $TEST_IMAGE_PHP-7.4-node16-dependency-scan
    - docker pull $TEST_IMAGE_PHP-7.4-node14-dependency-scan
  script:
    - docker run $TEST_IMAGE_PHP-7.4 php --version
    - docker run $TEST_IMAGE_PHP-7.4-node14 php --version
    - docker run $TEST_IMAGE_PHP-7.4-node14 node --version
    - docker run $TEST_IMAGE_PHP-7.4-node14-fpm php --version
    - docker run $TEST_IMAGE_PHP-7.4-node14-fpm node --version
    - docker run $TEST_IMAGE_PHP-7.4-node16 php --version
    - docker run $TEST_IMAGE_PHP-7.4-node16 node --version
    - docker run $TEST_IMAGE_PHP-7.4-node16-fpm php --version
    - docker run $TEST_IMAGE_PHP-7.4-node16-fpm node --version
    - docker run $TEST_IMAGE_PHP-7.4-python-node14 php --version
    - docker run $TEST_IMAGE_PHP-7.4-python-node14 python --version
    - docker run $TEST_IMAGE_PHP-7.4-python-node16 php --version
    - docker run $TEST_IMAGE_PHP-7.4-python-node16 python --version
    - docker run $TEST_IMAGE_PHP-7.4-eb php --version
    - docker run $TEST_IMAGE_PHP-7.4-eb eb --version
    - docker run $TEST_IMAGE_PHP-7.4-node16-dependency-scan php --version
    - docker run $TEST_IMAGE_PHP-7.4-node16-dependency-scan node --version
    - docker run $TEST_IMAGE_PHP-7.4-node14-dependency-scan php --version
    - docker run $TEST_IMAGE_PHP-7.4-node14-dependency-scan node --version

test-php80:
  needs: [build-php80]
  stage: test
  before_script:
    - docker pull $TEST_IMAGE_PHP-8.0
    - docker pull $TEST_IMAGE_PHP-8.0-node14
    - docker pull $TEST_IMAGE_PHP-8.0-node16
    - docker pull $TEST_IMAGE_PHP-8.0-python
    - docker pull $TEST_IMAGE_PHP-8.0-eb
    - docker pull $TEST_IMAGE_PHP-8.0-node14-fpm
    - docker pull $TEST_IMAGE_PHP-8.0-node16-fpm
    - docker pull $TEST_IMAGE_PHP-8.0-node16-dependency-scan
  script:
    - docker run $TEST_IMAGE_PHP-8.0 php --version
    - docker run $TEST_IMAGE_PHP-8.0-node14 php --version
    - docker run $TEST_IMAGE_PHP-8.0-node14 node --version
    - docker run $TEST_IMAGE_PHP-8.0-node16 php --version
    - docker run $TEST_IMAGE_PHP-8.0-node16 node --version
    - docker run $TEST_IMAGE_PHP-8.0-node14-fpm php --version
    - docker run $TEST_IMAGE_PHP-8.0-node14-fpm node --version
    - docker run $TEST_IMAGE_PHP-8.0-node16-fpm php --version
    - docker run $TEST_IMAGE_PHP-8.0-node16-fpm node --version
    - docker run $TEST_IMAGE_PHP-8.0-python php --version
    - docker run $TEST_IMAGE_PHP-8.0-python python --version
    - docker run $TEST_IMAGE_PHP-8.0-eb php --version
    - docker run $TEST_IMAGE_PHP-8.0-eb eb --version
    - docker run $TEST_IMAGE_PHP-8.0-node16-dependency-scan php --version
    - docker run $TEST_IMAGE_PHP-8.0-node16-dependency-scan node --version

test-php81:
  needs: [build-php81]
  stage: test
  before_script:
    - docker pull $TEST_IMAGE_PHP-8.1
    - docker pull $TEST_IMAGE_PHP-8.1-node14
    - docker pull $TEST_IMAGE_PHP-8.1-node16
    - docker pull $TEST_IMAGE_PHP-8.1-python
    - docker pull $TEST_IMAGE_PHP-8.1-eb
    - docker pull $TEST_IMAGE_PHP-8.1-node14-fpm
    - docker pull $TEST_IMAGE_PHP-8.1-node16-fpm
    - docker pull $TEST_IMAGE_PHP-8.1-node16-dependency-scan
  script:
    - docker run $TEST_IMAGE_PHP-8.1 php --version
    - docker run $TEST_IMAGE_PHP-8.1-node14 php --version
    - docker run $TEST_IMAGE_PHP-8.1-node14 node --version
    - docker run $TEST_IMAGE_PHP-8.1-node16 php --version
    - docker run $TEST_IMAGE_PHP-8.1-node16 node --version
    - docker run $TEST_IMAGE_PHP-8.1-node14-fpm php --version
    - docker run $TEST_IMAGE_PHP-8.1-node14-fpm node --version
    - docker run $TEST_IMAGE_PHP-8.1-node16-fpm php --version
    - docker run $TEST_IMAGE_PHP-8.1-node16-fpm node --version
    - docker run $TEST_IMAGE_PHP-8.1-python php --version
    - docker run $TEST_IMAGE_PHP-8.1-python python --version
    - docker run $TEST_IMAGE_PHP-8.1-eb php --version
    - docker run $TEST_IMAGE_PHP-8.1-eb eb --version
    - docker run $TEST_IMAGE_PHP-8.1-node16-dependency-scan php --version
    - docker run $TEST_IMAGE_PHP-8.1-node16-dependency-scan node --version

test-cypress:
  needs: [build-cypress]
  stage: test
  before_script:
    - docker pull $TEST_IMAGE_CYPRESS
  script:
    - docker run $TEST_IMAGE_CYPRESS pm2 --version 
    - docker run $TEST_IMAGE_CYPRESS cypress --version

release-php74:
  needs: [test-php74]
  stage: release
  only:
    - master
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $TEST_IMAGE_PHP-7.4
    - docker pull $TEST_IMAGE_PHP-7.4-node14
    - docker pull $TEST_IMAGE_PHP-7.4-node14-fpm
    - docker pull $TEST_IMAGE_PHP-7.4-node16
    - docker pull $TEST_IMAGE_PHP-7.4-node16-fpm
    - docker pull $TEST_IMAGE_PHP-7.4-python-node14
    - docker pull $TEST_IMAGE_PHP-7.4-python-node16
    - docker pull $TEST_IMAGE_PHP-7.4-eb
    - docker pull $TEST_IMAGE_PHP-7.4-node16-dependency-scan
    - docker pull $TEST_IMAGE_PHP-7.4-node14-dependency-scan
  script:
    # Tag all images
    - docker tag $TEST_IMAGE_PHP-7.4 $RELEASE_IMAGE_PHP:7.4
    - docker tag $TEST_IMAGE_PHP-7.4-node14 $RELEASE_IMAGE_PHP:7.4-node14
    - docker tag $TEST_IMAGE_PHP-7.4-node14-fpm $RELEASE_IMAGE_PHP:7.4-node14-fpm
    - docker tag $TEST_IMAGE_PHP-7.4-node16 $RELEASE_IMAGE_PHP:7.4-node16
    - docker tag $TEST_IMAGE_PHP-7.4-node16-fpm $RELEASE_IMAGE_PHP:7.4-node16-fpm
    - docker tag $TEST_IMAGE_PHP-7.4-python-node14 $RELEASE_IMAGE_PHP:7.4-python-node14
    - docker tag $TEST_IMAGE_PHP-7.4-python-node16 $RELEASE_IMAGE_PHP:7.4-python-node16
    - docker tag $TEST_IMAGE_PHP-7.4-eb $RELEASE_IMAGE_PHP:7.4-eb
    - docker tag $TEST_IMAGE_PHP-7.4-node16-dependency-scan $RELEASE_IMAGE_PHP:7.4-node16-dependency-scan
    - docker tag $TEST_IMAGE_PHP-7.4-node14-dependency-scan $RELEASE_IMAGE_PHP:7.4-node14-dependency-scan
    # Publish all images
    - docker push $RELEASE_IMAGE_PHP:7.4
    - docker push $RELEASE_IMAGE_PHP:7.4-node14
    - docker push $RELEASE_IMAGE_PHP:7.4-node14-fpm
    - docker push $RELEASE_IMAGE_PHP:7.4-node16
    - docker push $RELEASE_IMAGE_PHP:7.4-node16-fpm
    - docker push $RELEASE_IMAGE_PHP:7.4-python-node14
    - docker push $RELEASE_IMAGE_PHP:7.4-python-node16
    - docker push $RELEASE_IMAGE_PHP:7.4-eb
    - docker push $RELEASE_IMAGE_PHP:7.4-node16-dependency-scan
    - docker push $RELEASE_IMAGE_PHP:7.4-node14-dependency-scan

release-php80:
  needs: [test-php80]
  stage: release
  only:
    - master
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $TEST_IMAGE_PHP-8.0
    - docker pull $TEST_IMAGE_PHP-8.0-node14
    - docker pull $TEST_IMAGE_PHP-8.0-node16
    - docker pull $TEST_IMAGE_PHP-8.0-python
    - docker pull $TEST_IMAGE_PHP-8.0-eb
    - docker pull $TEST_IMAGE_PHP-8.0-node14-fpm
    - docker pull $TEST_IMAGE_PHP-8.0-node16-fpm
    - docker pull $TEST_IMAGE_PHP-8.0-node16-dependency-scan
  script:
    # Tag all images
    - docker tag $TEST_IMAGE_PHP-8.0 $RELEASE_IMAGE_PHP:8.0
    - docker tag $TEST_IMAGE_PHP-8.0-node14 $RELEASE_IMAGE_PHP:8.0-node14
    - docker tag $TEST_IMAGE_PHP-8.0-node16 $RELEASE_IMAGE_PHP:8.0-node16
    - docker tag $TEST_IMAGE_PHP-8.0-node14-fpm $RELEASE_IMAGE_PHP:8.0-node14-fpm
    - docker tag $TEST_IMAGE_PHP-8.0-node16-fpm $RELEASE_IMAGE_PHP:8.0-node16-fpm
    - docker tag $TEST_IMAGE_PHP-8.0-python $RELEASE_IMAGE_PHP:8.0-python
    - docker tag $TEST_IMAGE_PHP-8.0-eb $RELEASE_IMAGE_PHP:8.0-eb
    - docker tag $TEST_IMAGE_PHP-8.0-node16-dependency-scan $RELEASE_IMAGE_PHP:8.0-node16-dependency-scan
    # Publish all images
    - docker push $RELEASE_IMAGE_PHP:8.0
    - docker push $RELEASE_IMAGE_PHP:8.0-node14
    - docker push $RELEASE_IMAGE_PHP:8.0-node16
    - docker push $RELEASE_IMAGE_PHP:8.0-python
    - docker push $RELEASE_IMAGE_PHP:8.0-eb
    - docker push $RELEASE_IMAGE_PHP:8.0-node14-fpm
    - docker push $RELEASE_IMAGE_PHP:8.0-node16-fpm
    - docker push $RELEASE_IMAGE_PHP:8.0-node16-dependency-scan

release-php81:
  needs: [test-php81]
  stage: release
  only:
    - master
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $TEST_IMAGE_PHP-8.1
    - docker pull $TEST_IMAGE_PHP-8.1-node14
    - docker pull $TEST_IMAGE_PHP-8.1-node16
    - docker pull $TEST_IMAGE_PHP-8.1-python
    - docker pull $TEST_IMAGE_PHP-8.1-eb
    - docker pull $TEST_IMAGE_PHP-8.1-node14-fpm
    - docker pull $TEST_IMAGE_PHP-8.1-node16-fpm
    - docker pull $TEST_IMAGE_PHP-8.1-node16-dependency-scan
  script:
    # Tag all images
    - docker tag $TEST_IMAGE_PHP-8.1 $RELEASE_IMAGE_PHP:8.1
    - docker tag $TEST_IMAGE_PHP-8.1-node14 $RELEASE_IMAGE_PHP:8.1-node14
    - docker tag $TEST_IMAGE_PHP-8.1-node16 $RELEASE_IMAGE_PHP:8.1-node16
    - docker tag $TEST_IMAGE_PHP-8.1-node14-fpm $RELEASE_IMAGE_PHP:8.1-node14-fpm
    - docker tag $TEST_IMAGE_PHP-8.1-node16-fpm $RELEASE_IMAGE_PHP:8.1-node16-fpm
    - docker tag $TEST_IMAGE_PHP-8.1-python $RELEASE_IMAGE_PHP:8.1-python
    - docker tag $TEST_IMAGE_PHP-8.1-eb $RELEASE_IMAGE_PHP:8.1-eb
    - docker tag $TEST_IMAGE_PHP-8.1-node16-dependency-scan $RELEASE_IMAGE_PHP:8.1-node16-dependency-scan
    # Publish all images
    - docker push $RELEASE_IMAGE_PHP:8.1
    - docker push $RELEASE_IMAGE_PHP:8.1-node14
    - docker push $RELEASE_IMAGE_PHP:8.1-node16
    - docker push $RELEASE_IMAGE_PHP:8.1-python
    - docker push $RELEASE_IMAGE_PHP:8.1-eb
    - docker push $RELEASE_IMAGE_PHP:8.1-node14-fpm
    - docker push $RELEASE_IMAGE_PHP:8.1-node16-fpm
    - docker push $RELEASE_IMAGE_PHP:8.1-node16-dependency-scan

release-cypress:
  needs: [test-cypress]
  stage: release
  only:
    - master
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $TEST_IMAGE_CYPRESS
  script:
    - docker tag $TEST_IMAGE_CYPRESS $RELEASE_IMAGE_CYPRESS
    - docker push $RELEASE_IMAGE_CYPRESS
